define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for FichaUsuario generated by Appery.io
         * @module FichaUsuario
         */
        APP.controller('FichaUsuario', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.usuarios = Apperyio.EntityAPI('UserList');
            $scope.usuario = Apperyio.EntityAPI('User');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                $scope.showLoading();
                $scope.codigoUsuario = Apperyio.get('userManager').operatorId;
                $scope.usernameUsuario = Apperyio.get('userManager').operatorUsername;
                $scope.datosEmpresa = JSON.parse(localStorage.getItem("companyData"));
                var requestData = {};
                requestData = (function mapping3551($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "username": $scope.usernameUsuario
                            },
                            {
                                "codigoOperador": $scope.codigoUsuario
                            },
                        ]
                    };
                    return requestData;
                    /*|button_mapping|onbeforesend|2043F28F-3D88-A0B1-21FA-6700A6081663||3551|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_user_query_service")(requestData).then( /*|service_bookmark|bookmark|2043F28F-3D88-A0B1-21FA-6700A6081663||5360|*/
                    function(success) { // success callback
                        (function mapping9355(success, $scope) {
                            var usuario_scope = $scope.usuarios;
                            for (var i = 0, l = success.data.length; i < l; i++) {
                                _.set(usuario_scope, '[' + i + '].username', success.data[i].username);
                                _.set(usuario_scope, '[' + i + '].email', success.data[i].email);
                                _.set(usuario_scope, '[' + i + '].fullName', success.data[i].fullName);
                                _.set(usuario_scope, '[' + i + '].foto', success.data[i].foto);
                                _.set(usuario_scope, '[' + i + ']._id', success.data[i]._id);
                                _.set(usuario_scope, '[' + i + '].codigoOperador', success.data[i].codigoOperador);
                            }
                            $scope.usuarios = usuario_scope;
                            /*|button_mapping|onsuccess|2043F28F-3D88-A0B1-21FA-6700A6081663||9355|*/
                        })(success, $scope);
                        $scope.stopLoading();
                        $scope.usuario = $scope.usuarios[0];
                    },
                    function(error) { // callback to handle request error
                        $scope.stopLoading();
                        $scope.mAlert("Hubo errores al cargar los datos del usuario: " + error.data.code + " " + error.data.description);
                    },
                    function(notify) { // notify callback, can fire few times
                    });
                var requestData = {};
                requestData = (function mapping9548($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.params.where = {
                        "$and": [{
                                "idCliente": $scope.datosEmpresa.idCliente
                            },
                            {
                                "idOperador": $scope.codigoUsuario
                            },
                        ]
                    };
                    return requestData;
                    /*|button_mapping|onbeforesend|D86955C1-5C44-215E-0AC8-0EC69F8C0349||9548|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_OPERATORS_query_service")(requestData).then( /*|service_bookmark|bookmark|D86955C1-5C44-215E-0AC8-0EC69F8C0349||4397|*/
                    function(success) { // success callback
                        (function mapping1505(success, $scope) {
                            $scope.estadoUsuario = success.data[0].estadoOperador ? "Usuario Habilitado" : "Usuario Inhabilitado";
                            $scope.estadoUsrBool = success.data[0].estadoOperador;
                            $scope._id = success.data[0]._id;
                            /*|button_mapping|onsuccess|D86955C1-5C44-215E-0AC8-0EC69F8C0349||1505|*/
                        })(success, $scope);
                    },
                    function(error) { // callback to handle request error
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function actualizarDatos
             */
            $scope.actualizarDatos = function() {
                if ($scope.usuario.fullName === "") {
                    alert("El campo Nombre no puede ser vacío");
                    return;
                }
                if ($scope.usuario.newPassword) {
                    if ($scope.usuario.newPassword.length < 6) {
                        $scope.mAlert("La password debe tener al menos 6 caracteres");
                        return;
                    } else {
                        if ($scope.usuario.newPassword != $scope.usuario.newRePassword) {
                            $scope.mAlert("La password reingresada no coincide");
                            return
                        }
                    }
                }
                $scope.showLoading("Actualizando Datos...");
                var requestData = {};
                requestData = (function mapping6625($scope) {
                    var requestData = {};
                    requestData.headers = {};
                    requestData.data = {};
                    requestData.params = {};
                    var usuario_scope = $scope.usuario;
                    //requestData.headers['X-Appery-Session-Token'] = usuario_scope.token;
                    _.set(requestData.data, 'fullName', usuario_scope.fullName);
                    if ($scope.usuario.newPassword) {
                        _.set(requestData.data, 'password', usuario_scope.newPassword);
                    }
                    requestData.params._id = usuario_scope._id;
                    return requestData;
                    /*CLICK TO EDIT MAPPING*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_user_update_service")(requestData).then(
                    function(success) { // success callback
                        /*CLICK TO EDIT MAPPING*/
                        $scope.stopLoading();
                        $scope.usuario.newPassword = "";
                        $scope.usuario.newRePassword = "";
                    },
                    function(error) { // callback to handle request error
                        alert("Hubo problemas al actualizar los datos: " + error.data.code + " " + error.data.description);
                        $scope.stopLoading();
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function habilitarUsuario
             */
            $scope.habilitarUsuario = function() {
                $scope.showLoading("Actualizando Datos...");
                var requestData = {};
                requestData = (function mapping7243($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.data = {};
                    requestData.params._id = $scope._id;
                    _.set(requestData.data, 'estadoOperador', true);
                    return requestData;
                    /*|button_mapping|onbeforesend|FB23F81B-1AAD-15A1-1D60-28A6BEA74CBC||7243|*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_OPERATORS_update_service")(requestData).then( /*|service_bookmark|bookmark|FB23F81B-1AAD-15A1-1D60-28A6BEA74CBC||2711|*/
                    function(success) { // success callback
                        /*|button_mapping|onsuccess|FB23F81B-1AAD-15A1-1D60-28A6BEA74CBC||6532|*/
                        $scope.estadoUsuario = "Usuario Habilitado";
                        $scope.estadoUsrBool = true;
                        $scope.stopLoading();
                        //$scope.init();
                    },
                    function(error) { // callback to handle request error
                        alert("Hubo problemas al actualizar los datos: " + error.data.code + " " + error.data.description);
                        $scope.stopLoading();
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function inhabilitarUsuario
             */
            $scope.inhabilitarUsuario = function() {
                $scope.showLoading("Actualizando Datos...");
                var requestData = {};
                requestData = (function mapping7243($scope) {
                    var requestData = {};
                    requestData.params = {};
                    requestData.data = {};
                    requestData.params._id = $scope._id;
                    _.set(requestData.data, 'estadoOperador', false);
                    return requestData;
                    /*CLICK TO EDIT MAPPING*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_OPERATORS_update_service")(requestData).then(
                    function(success) { // success callback
                        /*CLICK TO EDIT MAPPING*/
                        $scope.estadoUsuario = "Usuario Inhabilitado";
                        $scope.estadoUsrBool = false;
                        $scope.stopLoading();
                        //$scope.init();
                    },
                    function(error) { // callback to handle request error
                        alert("Hubo problemas al actualizar los datos: " + error.data.code + " " + error.data.description);
                        $scope.stopLoading();
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
        }
    });